#ifndef GRAPH_PROPERTY_WRITER_H_INCLUDED_
#define GRAPH_PROPERTY_WRITER_H_INCLUDED_

#include "segment_graph.h"

#include <iostream>

namespace risc {

namespace sg {

struct GraphPropertyWriter {

  GraphPropertyWriter(Graph& graph);

  friend std::ostream& operator<< (std::ostream &out,
                           const GraphPropertyWriter &gpw)
  {
    return out;
  }

  Graph& graph_;

  void operator() (std::ostream &out)
  {
    out << "node [style=rounded];" << std::endl;
  }
};

}; // end of namespace sg

}; // end of namespace risc

#endif /* GRAPH_PROPERTY_WRITER_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
