#include "command_line_parsing.h"

#include <limits.h>

std::vector<std::string>
risc::tools::preparsing_commandline_arguments(int &argc, char **&argv,
    std::vector<std::string> &input_files)
{
  std::vector<std::string> arguments =
    CommandlineProcessing::generateArgListFromArgcArgv(argc, argv);

  input_files = CommandlineProcessing::generateSourceFilenames(arguments, true);

  if(input_files.size() == 0)
    return arguments;

  argc = 0;
  argv = NULL;

  std::string new_file("__main__.cpp");

  std::ofstream myfile;
  myfile.open(new_file.c_str(), std::ios::out);

  if(!myfile.is_open()) {
    std::cout << "Cannot create merged file" << std::endl;
    return arguments;
  }

  for(std::vector<std::string>::iterator
      iter  = input_files.begin();
      iter != input_files.end();
      iter++) {

    if(CommandlineProcessing::isSourceFilename(*iter)) {

      myfile << "#include \"" << (*iter).c_str() << "\"" << std::endl;

      arguments.erase(
                    std::remove(arguments.begin(), arguments.end(), *iter),
                    arguments.end());
    }
  }

  myfile.close();

  arguments.insert(++(arguments.begin()), new_file);

  CommandlineProcessing::generateArgcArgvFromList(arguments,argc,argv);

  return arguments;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
